import java.util.*;
import java.text.*;

class Grupo extends Usuario{
  // Atributos privados.
  private ArrayList <Pessoa> membros;

  // Geters
  // Retorna o membro que esta no indice ind do grupo
  public Pessoa getMembro(int ind){
    return(this.membros.get(ind));
  }

  // Retorna o indice do membro membroProcurado que esta no grupo
  public int getIndice(Pessoa membroProcurado){
    return(this.membros.indexOf(membroProcurado));
  }

  // Metodos
  public void adicionaMembro(Pessoa membro){
    this.membros.add(membro);
  }
  public void removeMembro(Pessoa membro){
    this.membros.remove(membro);
  }

  // métodos
  public void publicaPensamento(String conteudo){
    Relacao atual;
    String resultado;

    Pensamento novoPensamento = new Pensamento(conteudo, this);
    this.pensamentos.add(novoPensamento);
    // notifica observadores
    resultado = String.format("%s publicou: %s", this.nome, conteudo);
    this.publicacoes.add(resultado);
    // this.nome publicou "conteudo"
  }

  public void publicaComentario(String conteudo, Pensamento pensamento){
    Relacao atual;
    String resultado;

    Comentario novoComentario = new Comentario(pensamento, conteudo, this);
    this.comentarios.add(novoComentario);
    // notifica observadores
    resultado = String.format("%s comentou: %s no pensamento %s de %s", this.nome, conteudo, pensamento.conteudo, pensamento.usuario.nome);
    this.publicacoes.add(resultado);
    // this.nome comentou "conteudo" no pensamento "pensamento.conteudo" de pensamento.usuario
  }

  public void publicaLike(Pensamento pensamento){
    Relacao atual;
    String resultado;

    Like novoLike = new Like(pensamento, this);
    this.likes.add(novoLike);
    // notifica observadores
    resultado = String.format("%s curtiu o pensamento %s de %s", this.nome, pensamento.conteudo, pensamento.usuario.nome);
    this.publicacoes.add(resultado);
    // this.nome curtiu o pensamento "pensamento.conteudo" de pensamento.usuario
  }

  public void publicaDislike(Pensamento pensamento){
    Relacao atual;
    String resultado;

    Dislike novoDislike = new Dislike(pensamento, this);
    this.dislikes.add(novoDislike);
    // notifica observadores
    resultado = String.format("%s nao curtiu o pensamento %s de %s", this.nome, pensamento.conteudo, pensamento.usuario.nome);
    this.publicacoes.add(resultado);
    // this.nome não curtiu o pensamento "pensamento.conteudo" de pensamento.usuario
  }

  // Construtor
  public Grupo(String novoNome, String novoLogin){
    this.membros = new ArrayList <Pessoa>();
    this.setNome(novoNome);
    this.setLogin(novoLogin);
    this.setDataCriacao();
    pensamentos = new ArrayList <Pensamento>();
    comentarios = new ArrayList <Comentario>();
    likes = new ArrayList <Like>();
    dislikes = new ArrayList <Dislike>();
    timeline = new ArrayList <String>();
    publicacoes = new ArrayList<String>();
  }
}
